﻿using BinaryDad.AggregateDal.Models;

namespace BinaryDad.AggregateDal
{
    public interface ISettlementAttemptDataAccess
    {
        /// <summary>
        /// Adds a new settlement attempt
        /// </summary>
        /// <param name="attempt"></param>
        /// <returns>Whether the add operation was successful</returns>
        bool AddAttempt(SettlementAttempt attempt);

        /// <summary>
        /// Updates an attempt
        /// </summary>
        /// <param name="attempt">An existing attempt to update</param>
        /// <returns></returns>
        bool UpdateAttempt(SettlementAttempt attempt);

        /// <summary>
        /// Retrieves an existing settlement attempt
        /// </summary>
        /// <param name="recordId"></param>
        /// <returns></returns>
        SettlementAttempt GetAttempt(int recordId);
    }
}
